// Written by TeTeT
// display a dialog and rotate it toward the beacon
// based on BIS sample

beacons = [beacon, beacon1, beacon2];

activeBeacon = beacon;

[] spawn {

	angle = (player getRelDir activeBeacon);
	uiNamespace setVariable ["angle", angle];
	with uiNamespace do {
		activeBeaconFreq = "1000";

		if (!isNil "ctrl") then {
			ctrlDelete ctrl;
		};
		while {isNull (findDisplay 46)} do {
			sleep 0.1;
		};
		ctrl = findDisplay 46 ctrlCreate ["RscPictureKeepAspect", -1];;
		ctrl ctrlSetPosition [0,-0.55,0.5,0.5];
		ctrl ctrlSetText "data\Arrow.paa";
		ctrl ctrlSetAngle [angle, 0.5, 0.5];
		ctrl ctrlCommit 0;

		onEachFrame	{
			angle = (player getRelDir activeBeacon);
			uiNamespace setVariable ["angle", angle];
			with uiNamespace do {
				ctrl ctrlSetAngle [angle, 0.5, 0.5];
			};
		};

	};
};

beaconActive = true;

player addAction [
	"Show bearing indicator",
	"beaconActive = true; (uiNamespace getVariable 'ctrl') ctrlSetTextColor [1,1,1,1]",
	"",
	0,
	false,
	true,
	"",
	"!beaconActive"
];

player addAction [
	"Hide bearing indicator",
	"beaconActive = false; (uiNamespace getVariable 'ctrl') ctrlSetTextColor [1,1,1,0]",
	"",
	0,
	false,
	true,
	"",
	"beaconActive"
];

player addAction [
	"Enter beacon frequency",
	"createDialog 'FrequencyDialog';",
	"",
	0,
	false,
	true,
	"",
	"true"
];


changeFrequency = {
	private ["_freq", "_beacon"];

	_freq = parseNumber ctrlText 1000;
	_beacon = ObjNull;

	{
		private ["_beaconFreq"];
		_beaconFreq = _x getVariable ["frequency", 0];
		if (_freq == _beaconFreq) then {
			_beacon = _x;
		};
	} forEach beacons;

	if (isNull _beacon) then {
		(vehicle player) vehicleChat "No beacon on that frequency";
	} else {
		activeBeacon = _beacon;
	};
	_beacon;
};