// Written by TeTeT for NightIntruder

#define HELOTYPE "Helicopter"
#define HELOFACTOR 1
#define MAXLOAD 1200
// Wind effect will cease at this speed
#define MAXSPEED 50
// Maximum wind effect when helo is lower than
#define HEIGHT 60

#ifndef EFUNC
#define EFUNC(a, b) {}
#endif


waitUntil {alive player};
sleep 1;
systemChat "Soon weather will be initialized here";

[] execVM "WMinit.sqf";

waitUntil {!isNil "WMinitComplete"};

systemChat "Weather Module initialization done";

WMTempEffect = {
	while {alive player} do
	{
		// TeTeT: what is helomass good for?
		_helomass = getMass vehicle player;  //helomass might be good for adjusting HELOFACTOR and scale the wind effect against size & mass of a heli, we need some math for it tho
		// TeTeT: added a sleep
		waitUntil {sleep 1; vehicle player != player};
		_veh = vehicle player;
		if (_veh isKindOf HELOTYPE) then
		{
			if (!isNil "ace_common") then
			{
				while {vehicle player == _veh && alive _veh} do
				{
					private ["_playerDir", "_playerAltitude", "_temperature", "_altitude"];
					_playerDir = getDir ACE_player;
					_playerAltitude = (getPosASL ACE_player) select 2;
					_temperature = [_playerAltitude] call ttt_weather_fnc_weather_efunc;
					_newmass = ((2.1897*_temperature)^2-(17.283*_temperature)+75.7091)/2.36038;
					_veh setCustomWeightRTD _newmass;
					hint format ["NEWMASS:%1   HELIMASS:%2", floor(_newmass * HELOFACTOR), _helomass];
					sleep 2;
				};
				sleep 2;
			}
			else
			{
				while {vehicle player == _veh && alive _veh} do
				{
					//_WMtemp = missionNamespace getVariable "WMtempPublic"; it doesn't work with it, I need to get value of the WMtempPublic, you can find it in WIMinit.sqf
					private ["_pseah", "_tempH", "_WMtempH", "_newmass"];
					_pseah = getPosASL _veh select 2;
					_tempH = 0.0065 * _pseah;
					_WMtempH = WMtempPublic - _temph;
					// TeTeT: suggest to give 2.1897 and those other constants a telling name as define
					_newmass = ((2.1897*_WMtempH)^2-(17.283*_WMtempH)+75.7091)/2.36038;
					// TeTeT: for the humming bird divide by 10
					_veh setCustomWeightRTD _newmass * HELOFACTOR;
					hint format ["NEWMASS:%1   HELIMASS:%2", floor(_newmass * HELOFACTOR), _helomass];
					sleep 2;
				};
				sleep 2;
			};
		};
		hint "exiting vehicle...";
		_veh setCustomWeightRTD 0;
	};
};


// Set wind strength and direction in a loop and alter globals
WMcalcWind =
{
	// no wind blowing from north
	NewWindStrength = floor(random 100);
	NewWindDirection = floor(random 360);
	// alter wind
	while {time > 0 and isServer} do
	{
		if (!isNil "ace_common") then
		{
			// up to 100 km/h
			private ["_WindStrength", "_WindDirection"];
			_WindStrength = (vectorMagnitude ACE_wind * 3.6);
			if (_WindStrength < 0) then
			{
				NewWindStrength = 0;
			};
			if (_WindStrength > 100) then
			{
				NewWindStrength = 100;
			};
			// change direction
			_WindDirection = (ACE_wind select 0) atan2 (ACE_wind select 1);
			if (_WindDirection < 0) then { NewWindDirection = _WindDirection + 360;} else {NewWindDirection = _WindDirection;};
			publicVariable "NewWindStrength";
			publicVariable "NewWindDirection";
			systemChat format ["wind dir: %1 wind strength: %2", NewWindDirection, NewWindStrength];
			// frequent changes
			sleep 5;
		}
		else
		{
			// up to 100 km/h
			private ["_newWindStrength", "_newWindDirection"];
			NewWindStrength = (windStr * 3.6);
			if (NewWindStrength < 0) then
			{
				NewWindStrength = 0;
			};
			if (NewWindStrength > 100) then
			{
				NewWindStrength = 100;
			};
			// change direction
			NewWindDirection = windDir;
			publicVariable "NewWindStrength";
			publicVariable "NewWindDirection";
			systemChat format ["wind dir: %1 deg, wind strength: %2 kph", NewWindDirection, NewWindStrength];
			// frequent changes
			sleep 10;
		};
	};
};


WMWindEffect = {
	// effect heli with wind
	while {alive player} do
	{
		waitUntil {sleep 1; vehicle player != player and (vehicle player) isKindOf HELOTYPE};
		private ["_veh"];
		_veh = vehicle player;
		while {alive _veh and vehicle player == _veh} do
		{
			// needs to be included to get access to ACE3's functions, right?
			private ["_customWeight", "_modWeight", "_heightModifier", "_windOffset", "_diff", "_heliDir"];
			// get the custom weight from the helo
			_customWeight = weightRTD _veh select 3;
			// establish a modifier for custom weight
			if (speed _veh > MAXSPEED) then
			{
				_modWeight = 0;
			}
			else
			{
				// height modifier
				if (getPosATL _veh select 2 < HEIGHT) then
				{
					_heightModifier = 1.0;
				}
				else
				{
					_heightModifier = 0;
				};
				_windOffset = 0;
				_heliDir = getDir _veh;
				_diff = abs(NewWindDirection - _heliDir);
				if (_diff < 15) then
				{
					_windOffset = 1.0;
				};
				if (_diff > 15) then
				{
					_windOffset = 0.75;
				};
				if (_diff > 45) then
				{
					_windOffset = 0.5;
				};
				if (_diff > 75) then
				{
					_windOffset = 0.375;
				};
				if (_diff > 105) then
				{
					_windOffset = 0.25;
				};
				if (_diff > 135) then
				{
					_windOffset = 0.125;
				};
				if (_diff > 165) then
				{
					_windOffset = 0.0;
				};
				_modWeight = floor(MAXLOAD * _heightModifier * (NewWindStrength / 100 * _windOffset));
			};
			// adjust custom weight
			_veh setCustomWeightRTD (_customWeight + _modWeight);
			systemChat format ["Adjusted weight by %1 kG", _modWeight];
			sleep 1;
		};
	};
};



[] spawn WMcalcWind;
if (hasInterface) then
{
	[] spawn WMWindEffect;
	[] spawn WMTempEffect;
};